diff --git a/src/refdb.c b/src/refdb.c
index 55d7bac7..1e29d1f6 100644
--- a/src/refdb.c
+++ b/src/refdb.c
@@ -170,12 +170,8 @@ add_to_refs(const char *id, size_t idlen, char *name, size_t namelen, struct ref
 		*ref_slot = ref;
 	}
 
-	if (strncmp(ref->id, id, idlen))
-		opt->changed |= WATCH_REFS;
-
 	ref->valid = TRUE;
 	ref->type = type;
-	string_ncopy_do(ref->id, SIZEOF_REV, id, idlen);
 
 	if (type == REFERENCE_HEAD) {
 		if (!refs_head ||
@@ -187,6 +183,12 @@ add_to_refs(const char *id, size_t idlen, char *name, size_t namelen, struct ref
 	if (type == REFERENCE_TAG)
 		refs_tags++;
 
+	if (!strncmp(ref->id, id, idlen))
+		return OK;
+
+	opt->changed |= WATCH_REFS;
+	string_ncopy_do(ref->id, SIZEOF_REV, id, idlen);
+
 	ref_lists_slot = string_map_put_to(&refs_by_id, id);
 	if (!ref_lists_slot)
 		return OK;
diff --git a/src/repo.c b/src/repo.c
index b77b2fa6..a073eb07 100644
--- a/src/repo.c
+++ b/src/repo.c
@@ -64,9 +64,10 @@ read_repo_info(char *name, size_t namelen, char *value, size_t valuelen, void *d
 
 	} else if (!strcmp(arg, REPO_INFO_SYMBOLIC_HEAD)) {
 		if (!prefixcmp(name, "refs/heads/")) {
+			const char *head = name + STRING_SIZE("refs/heads/");
+
+			string_ncopy(repo.head, head, strlen(head) + 1);
 			add_ref(repo.head_id, name, repo.remote, repo.head);
-			name += STRING_SIZE("refs/heads/");
-			string_ncopy(repo.head, name, strlen(name) + 1);
 		}
 		state->argv++;
 	}
diff --git a/test/regressions/github-370-test b/test/regressions/github-370-test
new file mode 100755
index 00000000..09e66bc2
--- /dev/null
+++ b/test/regressions/github-370-test
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+# Issue #370
+
+. libtest.sh
+. libgit.sh
+
+steps '
+	s
+	R
+	q
+'
+
+in_work_dir create_repo_from_tgz "$base_dir/files/scala-js-benchmarks.tgz"
+test_tig
